;Jaws scripts for thunder bird.
;june 4th 2007
;version 1.2
;Written by Daniel Dalton.
;contact details
;Email: daniel.dalton@iinet.net.au
;Skype: daniel_3680
;web:
;http://members.iinet.net.au/~ddalton/
;I hope the scripts are useful.
;Please contact me with comments, suggestions or even questions.
;Enjoy!

;include statements
include "thunderbird.jsm" ;thunderbird message file.
Include "hjconst.jsh" ;hjconst file
Include "common.jsm"
Include "HjGlobal.jsh" 
Void Function AutoStartEvent ()
;auto start event function.
;this function happens every time thunderbird is brought to the focus.
;written by daniel dalton.
var
	string sProduct,
	string sVersion

	let sProduct = GetVersionInfoString (GetAppFilePath (), cmsg282_L)
	let sVersion = GetVersionInfoString (GetAppFilePath (), cmsg283_L)

If SVersion =="2.0.0.0" then
SayFormattedMessage (OT_JAWS_MESSAGE, MSGautoStart)
else
SayFormattedMessage (OT_ERROR, "You are not using thunderbird 2.0. You can still use the scripts but they may not function correctly. Please consider upgrading")
EndIf
EndFunction



String Function LocalFolders ()
;since a lot more scripts will need to access the local folders tree view I thought I would write this function.
;just puts the user in the local folders tree view if called by a script.
;jaws doesn't say anything unless the script has say functions in it.
;written by daniel dalton
SaveCursor ()
var
Handle Hwnd ;For the FindString
Let hwnd =GetFocus ()
InvisibleCursor ()
RouteInvisibleToPc ()
If FindString (Hwnd, "Local", S_BOTTOM, S_UNRESTRICTED) then
RoutePCToInvisible ()
Return True
else
Return false
EndIf
EndFunction






String Function Compose (int ComposeValue)
;Checks if in the compose window.
;written by daniel dalton.
SaveCursor ()
var
String Title
Let Title =GetAppTitle ()
Let ComposeValue =StringContains (title, "Compose:")
If ComposeValue ==1 then
Return true
else
Return False
endif
EndFunction



String Function CheckIfInMessage ()
;checks if in a message.
;written by daniel dalton
SaveCursor ()
var
string date,
handle hwnd
InvisibleCursor ()
RouteInvisibleToPc ()
Let date ="Date:"
Let Hwnd =GetFocus ()
If FindString (Hwnd, date, S_TOP, S_UNRESTRICTED) then
InvisibleCursor ()
JAWSHome ()
else
return false
EndIf
If GetWord () ==date then
Return true
else
Return false
EndIf
EndFunction

String Function ReadMessageField (string MessageError, string FieldToSearchFor)
;written by daniel dalton
;reads the specified field
;wirtten by daniel dalton
SaveCursor ()
var
handle hwnd
Let hwnd =GetFocus ()
InvisibleCursor ()
RouteInvisibleToPc ()
If FindString (hwnd, FieldToSearchFor, S_TOP, S_UNRESTRICTED) then
SayFromCursor ()
RestoreCursor ()
Return true
else
SayFormattedMessage (OT_ERROR, MessageError)
RestoreCursor ()
return false
EndIf
EndFunction

String Function CopyField (string Field, string ErrorMessage, int ChopHowManyCharacters)
;written by daniel dalton
;does the same as the previous function but copies the information to the clip board.
SaveCursor ()
var
handle hwnd
Let hwnd =GetFocus ()
InvisibleCursor ()
RouteInvisibleToPc ()
If FindString (hwnd, field, S_TOP, S_UNRESTRICTED) then
JAWSHome ()
NextWord ()
Let Field =GetToEndOfLine ()
Let field =stringChopRight (field, ChopHowManyCharacters)
CopyToClipboard (field)
SayFormattedMessage (OT_JAWS_MESSAGE, field)
SayFormattedMessage (OT_JAWS_MESSAGE, "copied")
return true
else
SayFormattedMessage (OT_ERROR, ErrorMessage)
EndIf
EndFunction



Script FindLocalFolders ()
;This script puts the user in the local folders tree view.
;written by daniel dalton.
SaveCursor ()
LocalFolders ()
If LocalFolders () ==1 then

Else
SayFormattedMessage (OT_ERROR, MsgCanNotFindLocalFolders_L, MsgCanNotFindLocalFolders_s)
RestoreCursor ()
EndIf
EndScript



Script GetMail ()
;Connects to send and receive
;written by daniel dalton
var
Handle Hwnd ;Used for the find string.
Let Hwnd =GetFocus ()
SaveCursor ()
JAWSCursor ()
RouteJAWSToPc ()
If FindString (Hwnd, "Get Mail", S_TOP, S_UNRESTRICTED) then
SaveCursor ()
InvisibleCursor ()
SayFormattedMessage (OT_NO_DISABLE, MsgGetMail)
RestoreCursor ()
RoutePcToJAWS ()
else
SayFormattedMessage (OT_ERROR, MsgGetMailError_L, MsgGetMailError_S)
EndIf
RestoreCursor ()
EndScript



Script NewMessage ()
;Opens up a new message.
;Changed the keystroke so it was more like ms outlook.
;written by daniel dalton.
TypeKey ("Control +m")

EndScript



Script AddressBook ()
;Open the address book.
;written by daniel dalton
TypeKey ("Control +2")
EndScript



Script AddContact ()

;Add Contact script.
;quick way to add a contact.
;written by daniel dalton
SaveCursor ()
var
Int IMenuActive, ;See if the menu is active
int ISafety1, ;Safety for another while loop
Int ISafety ;Safety for the while loop
Let IMenuActive =MenusActive ()
Let ISafety =0 ;Set ISafety to 0
Let ISafety1 =0
SpeechOff ()
PCCursor ()
If IMenuActive ==0 then
ActivateMenuBar ()
else
ActivateMenuBar ()
ActivateMenuBar ()
EndIf
Pause ()
While (GetWord () !="New" &&ISafety <=20)
NextLine ()
If GetWord () =="New" then
Let ISafety =50 ;End the while loop.
EnterKey ()
EndIf
Let ISafety =ISafety +1 ;Count the while up.
EndWhile
Pause ()
While (GetLine () !="Address Book Card" &&ISafety1 <=7)
NextLine ()
If GetLine () =="Address Book Card" then
Let ISafety1 =40
EnterKey ()
EndIf
Let ISafety1 =ISafety1 +1
EndWhile
SpeechOn ()
RestoreCursor ()
EndScript


Script HotKeyHelp ()
;Hot key help script
;written by daniel dalton
var
int iDisplayVirtViewer 

Let iDisplayVirtViewer =  GetJCFOption (OPT_Virt_Viewer)  
 SetJCFOption (Opt_Virt_Viewer, 0) 
If UserBufferIsActive () then
UserBufferDeactivate ()
EndIf
SayFormattedMessage (OT_User_Buffer, MsgHotKeyHelp)
SetJCFOption (OPT_Virt_Viewer, iDisplayVirtViewer )
EndScript




Script send ()
;clicks on the send button when in a message.
;written by daniel dalton
var
Handle Hwnd ;For the FindString.
Let Hwnd =GetFocus ()
SaveCursor ()
InvisibleCursor ()
RouteInvisibleToPc ()
JAWSTopOfFile ()
JAWSHome ()
If GetWord () =="Compose:" then
If FindString (Hwnd, "Send", S_TOP, S_UNRESTRICTED) then
SayWord ()
RoutePCToInvisible ()
else
SayFormattedMessage (OT_ERROR, MsgSend_Error)
EndIf
EndIf
EndScript



Script GoToInbox ()
;takes the user to the list of messages in the global inbox.
;written by daniel dalton
;still not working correctly
SaveCursor ()
SpeechOff ()
var
Int ISafety, ;Safety for the while loop.
int ISafetyOpen ;another safety key
Let ISafety =0
LocalFolders ()
If LocalFolders () ==1 then
RoutePCToInvisible ()
NextCharacter ()
NextLine ()
NextLine ()
InvisibleCursor ()
RouteInvisibleToPc ()
While (GetWord () !="Inbox" &&ISafety <=10)
PriorLine ()
If GetWord () =="Inbox" then
Let ISafety =100
RoutePCToInvisible ()
EndIf
Let ISafety =ISafety +1
EndWhile
TabKey ()
else
SpeechOn ()
SayFormattedMessage (OT_ERROR, MsgInboxError_L, MsgInboxError_S)
RestoreCursor ()
Return
EndIf
SpeechOn ()
EndScript


Script AddToTo ()
;quick way to add a contact to the To  box.
;written by daniel dalton.
SaveCursor ()
var
Handle Hwnd,
int Window ;Tells us if where in the compose window or not.
Let Hwnd =GetFocus ()
Compose (Window)
If Compose (Window) ==1 then
InvisibleCursor ()
RouteInvisibleToPc ()
If FindString (Hwnd, "To:", S_BOTTOM, S_UNRESTRICTED) then
RoutePCToInvisible ()
else
SayFormattedMessage (OT_ERROR, MsgTo_Error_L, MsgTo_Error_S)
Return
EndIf
else
TypeCurrentScriptKey ()
EndIf

EndScript

Script AddToCC ()
;quick way to add a contact to the cc box.
;written by daniel dalton.
SaveCursor ()
var
Handle Hwnd,
int Window ;Tells us if where in the compose window or not.
Let Hwnd =GetFocus ()
Compose (Window)
If Compose (Window) ==1 then
InvisibleCursor ()
RouteInvisibleToPc ()
If FindString (Hwnd, "CC", S_BOTTOM, S_UNRESTRICTED) then
RoutePCToInvisible ()
else
SayFormattedMessage (OT_ERROR, MsgCCError_L, MsgCCError_S)
Return
EndIf
else
TypeCurrentScriptKey ()
EndIf
EndScript





Script ReadBoxInTabOrder ()
;Reads thru Dialog Box in Tab order
;written by daniel dalton.
SaveCursor ()
InvisibleCursor ()
RouteInvisibleToPc ()
JAWSTopOfFile ()
SayAll ()
RestoreCursor ()
EndScript



Script ScriptOptions ()
;Gives a list of options. 
;The options are:
;check for script updates. 
;brings up an input box
;the user then should type a version number.
;this script will then download this version if it is available.
;Go to the scripts website.
;go to the main jaws scripts for thunderbird page.
;includes info on what I hope to include in the next scripts as well as things already in the scripts.
;and a form which you can fill out with questions, comments or suggestions.
;go to the thunderbird website.
;takes the user to the thunderbird website.
;script written by daniel dalton
var
int IChoose,
string SVersion,
String website,
string list
Let list ="Check for script updates|go to the scripts website|Go to the thunderbird website"
Let IChoose=DlgSelectItemInList (list, "Jaws scripts for thunderbird ", false, 1)
If IChoose ==1 then
InputBox ("Check for which version", "Version", SVersion)
If SVersion !="" then
Let website ="http://members.iinet.net.au/~ddalton/Jaws%20scripts%20for%20thunderbird%20v" +SVersion +".zip"
SayFormattedMessage (OT_JAWS_MESSAGE, "Checking if version")
SayFormattedMessage (OT_JAWS_MESSAGE, SVersion)
SayFormattedMessage (OT_JAWS_MESSAGE, "is available")
Run (website)
else
Run ("http://members.iinet.net.au/~ddalton/DownloadScriptsForThunderbird.html")
SayFormattedMessage (OT_JAWS_MESSAGE, "Going to the download page for the scripts")
EndIf
EndIf
If IChoose ==2 then
Run ("http://members.iinet.net.au/~ddalton/ThunderBirdScripts.html")
SayFormattedMessage (OT_JAWS_MESSAGE, "Going to the thunderbird scripts main page")
ElIf IChoose ==3 then
Run ("http://www.mozilla.com/en-US/thunderbird/")
SayFormattedMessage (OT_JAWS_MESSAGE, "Going to the thunderbird website")
EndIf
EndScript

Script Attach ()
;quick way to add an attachment
;written by Daniel Dalton.
;written may 27th 2007
var
Handle Hwnd
Let Hwnd =GetFocus ()
SaveCursor ()
InvisibleCursor ()
JAWSTopOfFile ()
JAWSHome ()
If GetWord () !="Compose:" then
SayFormattedMessage (OT_ERROR, MsgNotInAmessage_L)
RestoreCursor ()
Return
else
RestoreCursor ()
SaveCursor ()
JAWSCursor ()
RouteJAWSToPc ()
EndIf
If FindString (Hwnd, "Attach", S_TOP, S_UNRESTRICTED) then
LeftMouseButton ()
LeftMouseButton ()
PCCursor ()
else
RestoreCursor ()
SayFormattedMessage (OT_ERROR, MsgAttachmentMessageError_L , MsgAttachmentMessageError_L)
EndIf
EndScript


Script Spell ()
;gives access to the spell check dialog through one keystroke.

;written by daniel dalton
;written on may 27th 2007
var
Handle Hwnd
Let Hwnd =GetFocus ()
SaveCursor ()
InvisibleCursor ()
JAWSTopOfFile ()
JAWSHome ()
If GetWord () !="Compose:" then
SayFormattedMessage (OT_ERROR, MsgNotInAmessage_L)
RestoreCursor ()
Return
else
RestoreCursor ()
SaveCursor ()
JAWSCursor ()
RouteJAWSToPc ()
EndIf
If FindString (Hwnd, "Spell", S_TOP, S_UNRESTRICTED) then
LeftMouseButton ()
LeftMouseButton ()
PCCursor ()
else
SayFormattedMessage (OT_ERROR, MsgSpellError_L , MsgSpellError_S)
RestoreCursor ()
EndIf


EndScript


Script ScriptFileName ()
;written by daniel dalton
;says the loaded scripts as well as the version number.
ScriptAndAppNames ("Thunderbird")
SayFormattedMessage (OT_JAWS_MESSAGE, "Scripts version 1.2")
EndScript





Script JumpToNextMessage ()
;quick way to go back a message when you are in the body of a message.
;written by daniel dalton.
;added on may 31 2007
SaveCursor ()
var
handle hwnd
InvisibleCursor ()
RouteInvisibleToPc ()
Let Hwnd =GetFocus ()
If FindString (Hwnd, "From", S_TOP, S_UNRESTRICTED) then
PCCursor ()
{f}
Pause ()
SayLine ()
else
TypeCurrentScriptKey ()
EndIf
RestoreCursor ()
EndScript


Script JumpBackAMessage ()
;quick way to jump back a message when you are in the body of a message.
;written by daniel dalton
;added may 31 2007
SaveCursor ()
var
handle hwnd
Let Hwnd =GetFocus ()
InvisibleCursor ()
RouteInvisibleToPc ()
If FindString (Hwnd, "From", S_TOP, S_UNRESTRICTED) then
PCCursor ()
{b}
Pause ()
SayLine ()
else
TypeCurrentScriptKey ()
EndIf
RestoreCursor ()
EndScript



Script From ()
;reads who the sender is.
;written by daniel dalton
var
string message,
string from
Let message ="Can't find the from field"
Let from ="From:"
If IsSameScript () then
 CopyField (from, message, 1)
else
ReadMessageField (message, from)
EndIf
EndScript


Script ReadDate ()
;reads the date of the message
;written by daniel dalton
var
string date,
string message
Let date ="Date:"
Let Message ="can't find the date of the message"
If IsSameScript () then
CopyField (date, message, 0)
else
ReadMessageField (message, date)
EndIf
EndScript


Script To ()
;reads the recipients address of the email.
;written by daniel dalton
var
handle Hwnd,
string copy,
String to,
String message
Let to ="To:"
Let Message ="To field not found"
If IsSameScript () then
SaveCursor ()
InvisibleCursor ()
RouteInvisibleToPc ()
If FindString (hwnd, to, S_TOP, S_UNRESTRICTED) then
JAWSHome ()
NextWord ()
NextWord ()
NextWord ()
Let Copy =GetToEndOfLine ()
CopyToClipboard (copy)
SayFormattedMessage (OT_JAWS_MESSAGE, copy)
SayFormattedMessage (OT_JAWS_MESSAGE, "copied")
RestoreCursor ()
Return
else
SayFormattedMessage (OT_ERROR, message)
RestoreCursor ()
Return
EndIf
else
ReadMessageField (message, to)
EndIf
EndScript


Script cc ()
;reads the cc field
;written by daniel dalton
var
string message,
string cc
Let message ="cc field not found"
Let cc ="cc"
If IsSameScript () then
CopyField (cc, message, 0)
else
ReadMessageField (message, cc)
EndIf
EndScript


Script bcc ()
;written by daniel dalton
;reads the bcc field
var
string message,
string bcc
Let bcc ="bcc:"
Let message ="bcc field not found"
If IsSameScript () then
CopyField (bcc, message, 0)
else
ReadMessageField (message, bcc)
EndIf
EndScript


Script subject ()
;quick way to read the subject field.
;written by daniel dalton
var
string message,
string subject
Let subject ="subject:"
Let message ="subject field not found"
If IsSameScript () then
CopyField (subject, message, 0)
else
ReadMessageField (message, subject)
EndIf
EndScript

Script ControlBackSpace ()
;written by daniel dalton
;improves the reading of the deleted word.
var
String STitle,
string SWord
Let STitle =GetAppTitle ()
If StringContains (STitle, "Compose") then
PriorWord ()
SayWord ()
NextWord ()
NextCharacter ()
TypeCurrentScriptKey ()
EndIf
EndScript




